# QuantStream

Welcome to the **QuantStream** documentation. QuantStream is a Python-based financial modeling preperation platform designed to interact with real-time financial data via APIs, including the Financial Modeling Prep (FMP) API. The platform provides tools for model training, real-time data integration, and visualization. It is designed to be a central data structure for financial modeling and analysis based on Xarray, allowing users to easily access and manipulate financial data for their projects.

## **Features**

- **FMP API Wrapper**: Integration with the FMP API for fetching financial data.
- **Data Visualization**: Display and interact with real-time financial data.
- **Data Export**: Download financial data in various formats such as CSV.
- **Data Storage**: Store financial data easily in a SQLite databases.
- **Extensible Architecture**: Easily add new models or financial data providers.
